#include "VehicleCommon.as"

// Car logic

void onInit(CBlob@ this )
{
    Vehicle_Setup( this,
                   250.0f, // move speed
                   0.31f,  // turn speed
                   Vec2f(0.0f, -2.5f), // jump out velocity
                   true  // inventory access
                 );
    Vehicle_SetupGroundSound( this, "WoodenWheelsRolling", // movement sound
                              1.0f, // movement sound volume modifier   0.0f = no manipulation
                              1.0f // movement sound pitch modifier     0.0f = no manipulation
                            );
						   
	{ CSpriteLayer@ w = Vehicle_addWoodenWheel( this, 0, Vec2f(9.0f,8.0f) ); if(w !is null) w.SetRelativeZ(10.0f); }
    { CSpriteLayer@ w = Vehicle_addWoodenWheel( this, 0, Vec2f(-1.0f,8.0f) ); if(w !is null) w.SetRelativeZ(10.0f); }
    { CSpriteLayer@ w = Vehicle_addWoodenWheel( this, 0, Vec2f(-11.0f,8.0f) ); if(w !is null) w.SetRelativeZ(10.0f); }
						   
    this.getShape().SetOffset(Vec2f(0,9));
    this.getShape().SetCenterOfMassOffset(Vec2f(-1.5f,4.5f));
	this.getShape().getConsts().transports = true;
	this.Tag("heavy weight");
    // override icon
 //   AddIconToken( "$"+this.getName()+"$", CFileMatcher("VehicleIcons.png").getFirst(), Vec2f(32,32), 2 );
}

bool canBePickedUp( CBlob@ this, CBlob@ byBlob )
{
    return !this.hasAttached() &&
			(!this.isInWater() || this.isOnMap()) &&
			this.getOldVelocity().LengthSquared() < 4.0f;
}

void onTick( CBlob@ this )
{
	this.set_s8("move_direction", 0);
	
    AttachmentPoint@[] aps;		 
    if (this.getAttachmentPoints( @aps ))
    {
        for (uint i = 0; i < aps.length; i++)
        {
            AttachmentPoint@ ap = aps[i];
            CBlob@ blob = ap.getOccupied();
			
			if (ap.isKeyPressed( key_down ))
			{
			if (this.isOnGround())
			{
			this.AddForce(Vec2f(0.0f,-5000.0f));
			}
			if (this.isInWater())
			{
			this.AddForce(Vec2f(0.0f,-300.0f));
			}
			}
			
    }
	}
	
    Vehicle_StandardControls( this );
    

}

void Vehicle_onFire( CBlob@ this, CBlob@ bullet, const u8 charge ) {}
bool Vehicle_canFire( CBlob@ this , bool isActionPressed, bool wasActionPressed, u8 &out chargeValue ) {return false;}

bool doesCollideWithBlob( CBlob@ this, CBlob@ blob )
{
	return Vehicle_doesCollideWithBlob_boat( this, blob );	
}

void onAttach( CBlob@ this, CBlob@ attached, AttachmentPoint @attachedPoint )
{
	Vehicle_onAttach( this, attached, attachedPoint );
}

void onDetach( CBlob@ this, CBlob@ detached, AttachmentPoint@ attachedPoint )
{
	Vehicle_onDetach( this, detached, attachedPoint );
}